/**
 * @author Nicolas Barradeau 
 */
	var animation = false;
	var size = 150;
	var w = 4;
	var h = 4;
	var d = 4;
	var length = 20;
	
	var gridGeom,
		gridMat,
		grid;
	
		
	
	var cylGeom = new THREE.CylinderGeometry( 0, 1.5, 1 );
	var sphereGeom = new THREE.IcosahedronGeometry( 1.5,1 );
	
		
	var white = new THREE.MeshBasicMaterial({color:0xDDDDDD } );
	var red = new THREE.MeshBasicMaterial({color:0xFF9900 } );
	
	var force = function( pos, length )
	{
		this.acc = new THREE.Vector3();
		this.vel = new THREE.Vector3();
		
		this.speed = Math.PI / 180 * 5;
		this.time = Math.random();
		
		this.update = function()
		{
			
			this.time += .1;
			
			this.acc.x += ( Math.random() - .5 ) * .01;
			this.acc.y += ( Math.random() - .5 ) * .01;
			this.acc.z += ( Math.random() - .5 ) * .01;
			this.acc.normalize();
			this.acc.multiplyScalar( Math.PI / 180 );
			
			this.vel.add( this.acc );
			this.vel.multiplyScalar( .9 );
			
			this.vel.x = utils.clamp( this.vel.x, -this.speed, this.speed );
			this.vel.y = utils.clamp( this.vel.y, -this.speed, this.speed );
			this.vel.z = utils.clamp( this.vel.z, -this.speed, this.speed );
			
			this.gr.rotation.add( this.vel );
			
		}
		
		this.dispose = function()
		{
			group.remove( this.gr );
		}
		
		this.gr = new THREE.Object3D();
		this.mesh = new THREE.Mesh( cylGeom, MAT_YELLOW );
		this.mesh.scale.y = length;
		this.mesh.position.y += length / 2;
		this.gr.add( this.mesh );
		
		this.mesh = new THREE.Mesh( sphereGeom, MAT_YELLOW );
		this.gr.add( this.mesh );
		this.gr.position.copy( pos );
		group.add( this.gr );
		
		this.update();
		return this;
		
	}
	
	function createGrid()
	{
		while( items.length > 0 )
		{
			items[ 0 ].dispose();
			items.shift();
		}
		
		if( grid != null )
		{
			gridGeom.dispose();
			group.remove( grid );
		}
		gridGeom = new THREE.CubeGeometry( size, size, size, w-1, h-1, d-1 );
		gridMat = getMeshMaterial( COLOR_GREY, 1, true );
		grid = new THREE.Mesh( gridGeom, gridMat );
		group.add( grid );
		
		
		var half = size / 2;
		var stepX = size / ( w - 1 );
		var stepY = size / ( h - 1 );
		var stepZ = size / ( d - 1 );
		
		for( var i = 0; i < w; i++ )
		{
			for( var j = 0; j < h; j++ )
			{
				for( var k = 0; k < d; k++ )
				{
				
					var pos = new THREE.Vector3( 	- half + i * stepX, 
													- half + j * stepY, 
													- half + k * stepZ );
						
					items.push( new force( pos, length || 1 + 25 * Math.random() ) );
					
				}
			}
		}
	}
	
	function reset( _w, _h, _d, _l )
	{
		
		w = _w;
		h = _h;
		d = _d;
		length = _l;
		createGrid();
	}
	reset( w, h, d, length );
	
	
	function update()
	{
		if( animation ) items.forEach( function( e, i, a ){	e.update();	});
	}
	setInterval( update, 1000 / 30 );
	
	
	function onDown( e )
	{
		animation = !animation ? true : false;
	}
	window.addEventListener( 'mousedown', onDown );
	
	