/**
 * @author Nicolas Barradeau 
 */
	//var utils = function(){};
	//utils.lerp = function( t, a, b ){ return a + t * ( b - a ); };
	//utils.norm = function( t, a, b ){ return ( t - a ) / ( b - a ); };
	//utils.map = function( t, a0, b0, a1, b1 ){ return utils.lerp( utils.norm( t, a0, b0 ), a1, b1 ); };
	//utils.clamp = function( t, min, max ){ return Math.min( max, Math.max( t, min ) ); };

	var animation = false;
	
	var size = 500;
	
	var w = 1;
	var h = 1;
	var d = 1;
	var _w = 250;
	var _h = 250;
	var _d = 250;
	
	var gravity = -0.05;
	var friction = 0.9;
	var damping = 0.1;
	
	var bounds = size * .5;
	var bbox = { 	x:-_w / 2, 
					y:-_h / 2, 
					z:-_d / 2, 
					w:_w / 2, 
					h:_h / 2, 
					d:_d / 2};
	
	var gridGeom,
		gridMat,
		grid;
	
	//var sphereGeom = new THREE.CubeGeometry( 1,1,1,1,1,1 );
	var sphereGeom = new THREE.IcosahedronGeometry( 5,2 );
	var white = new THREE.MeshBasicMaterial({color:0xDDDDDD } );
	var blendings = [ "NoBlending", "NormalBlending", "AdditiveBlending", "SubtractiveBlending", "MultiplyBlending", "AdditiveAlphaBlending" ];
	var blue = new THREE.MeshBasicMaterial({color:0xFF9900, transparent: true, opacity: 0.5, blending:THREE[ blendings[ 2 ] ] } );
	
	var lmat0 = new THREE.LineBasicMaterial( { color:0xFFFFFF , transparent: true, opacity: .5 });//, blending:THREE[ blendings[ 2 ] ] } );
	var lmat1 = new THREE.LineBasicMaterial( { color:0x006699 , transparent: true, opacity: .5, blending:THREE[ blendings[ 2 ] ] } );
	var lmat2 = new THREE.LineBasicMaterial( { color:0xFF9900 });//, transparent: true, opacity: 1, blending:THREE[ blendings[ 2 ] ] } );
	
	var geom0,
		line0,
		geom1,
		line1,
		geom2,
		line2,
		geom3,
		line3;
	
	var force = function( pos, strength )
	{
		this.pos = pos;
		this.acc = new THREE.Vector3( Math.random() - .5, Math.random() - .5, Math.random() - .5 );
		this.vel = new THREE.Vector3();
		
		this.strength = strength;
		this.time = Math.random();
		
		this.update = function()
		{
			
			this.time += .01;
			
			this.acc.x += ( Math.random() - .5 );//( Math.cos(this.time) ) * .01;
			this.acc.y += ( Math.random() - .5 );//( Math.sin(this.time) ) * .01;
			this.acc.z += ( Math.random() - .5 );//( Math.cos(this.time * 2) ) * .01;
			
			this.acc.normalize();
			
			this.vel.x += ( this.acc.x - this.vel.x ) * damping;
			this.vel.y += ( this.acc.y - this.vel.y ) * damping;
			this.vel.z += ( this.acc.z - this.vel.z ) * damping;
			
			//this.vel.add( this.acc );
			
			//this.vel.y = utils.clamp( this.vel.y, -this.strength, this.strength );
			//this.vel.z = utils.clamp( this.vel.z, -this.strength, this.strength );
			//this.vel.x = utils.clamp( this.vel.x, -this.strength, this.strength );
			
			this.vel.multiplyScalar( friction );
			
			this.mesh.scale.copy( this.vel );
			this.mesh.scale.multiplyScalar( this.strength );
			
		}		
		this.mesh = new THREE.Mesh( sphereGeom, blue );
		this.mesh.position.copy( pos );
		this.mesh.scale.multiplyScalar( 20 );
		//group.add( this.mesh );
		
		this.dispose = function()
		{
			group.remove( this.mesh );
		}
		this.update();
		return this;
		
	}
	
	////////////////////////////////////////////////
	
	var objects = [];
	var obj = function( pos, mass )
	{
		
		this.speed = 5;
		this.invMass = 1 / mass;
		
		this.pos = pos.clone();
		this.acc = new THREE.Vector3(0,0,0);
		this.vel = new THREE.Vector3(0,0,0);
		this.force = new THREE.Vector3(0,0,0);
		this.last = new THREE.Vector3(0,0,0);
		this.last.copy( pos );
		this.dead = false;
		this.update = function()
		{
			if( this.dead )return;
			var dx = 0,
				dy = 0,
				dz = 0;
			for( var i = 0; i < items.length; i++ )
			{
				
				this.force = items[ i ].vel.clone();
				this.force.normalize();
				//console.log( 'acc before ', this.acc );
				//console.log( 'force', this.force.x, this.force.y, this.force.z );
				
				var dist = items[ i ].pos.distanceTo( this.mesh.position );
				if( dist < 1 ) continue;
				
				var attenuation = ( items[ i ].strength / dist ) * this.invMass;
				
				this.force.multiplyScalar( attenuation );
				//dx += this.force.x;
				//dy += this.force.y;
				//dz += this.force.z;
				this.acc.add( this.force );
			}
			this.acc.y += gravity;
			
			//console.log( 'acc after ', this.acc );
				
			//add gravity
			//this.acc.y += gravity;
			
			//this.vel.add( this.acc );
			//console.log( '->',this.acc, this.vel );
			
			//this.acc.multiplyScalar( friction );
			//console.log( 'acc', this.acc.x, this.acc.y, this.acc.z );
			
			//this.acc.y = utils.clamp( this.acc.y, -this.speed, this.speed );
			//this.acc.z = utils.clamp( this.acc.z, -this.speed, this.speed );
			//this.acc.x = utils.clamp( this.acc.x, -this.speed, this.speed );
			
			this.last.copy( this.pos );
			
			this.mesh.position.add( this.acc );
			//var dist = this.mesh.position.distanceTo( new THREE.Vector3(0,0,0) );
			//this.mesh.position.normalize( );
			//this.mesh.position.multiplyScalar( _w / 2 );
			this.pos.copy( this.mesh.position );
			
			if( this.mesh.position.x < bbox.x ) this.acc.x *= -.9;
			if( this.mesh.position.y < bbox.y ) this.acc.y *= -.9;
			if( this.mesh.position.z < bbox.z ) this.acc.z *= -.9;
			if( this.mesh.position.x > bbox.w ) this.acc.x *= -.9;
			if( this.mesh.position.z > bbox.d ) this.acc.z *= -.9;
			
			if( this.mesh.position.y > bbox.h ) this.acc.y *= -.9;
			
			//if( this.mesh.position.x < bbox.x ) this.dead = true;//this.mesh.position.x = bbox.x;
			//if( this.mesh.position.y < bbox.y ) this.dead = true;//this.mesh.position.y = bbox.y;
			//if( this.mesh.position.z < bbox.z ) this.dead = true;//this.mesh.position.z = bbox.z;
			//if( this.mesh.position.x > bbox.w ) this.dead = true;//this.mesh.position.x = bbox.w;
			//if( this.mesh.position.y > bbox.h ) this.dead = true;//this.mesh.position.y = bbox.h;
			//if( this.mesh.position.z > bbox.d ) this.dead = true;//this.mesh.position.z = bbox.d;
			
			
			
			
			//if( this.dead ) objects.splice( objects.indexOf( this ), 1 );
		}
		
		this.dispose = function()
		{
			group.remove( this.mesh );
		}
		
		this.mesh = new THREE.Mesh( sphereGeom, white );
		this.mesh.position.copy( pos );
		//this.mesh.scale.multiplyScalar( 5 );
		group.add( this.mesh );
		
		objects.push( this );
		return this;
	}
	
	////////////////////////////////////////////////
	
	function createGrid()
	{
		while( items.length > 0 )
		{
			//items[ 0 ].dispose();
			items.shift();
		}
		
		if( grid != null )
		{
			gridGeom.dispose();
			group.remove( grid );
		}
		
		gridGeom = new THREE.CubeGeometry( _w * 1, _h * 1, _d * 1, w-1, h-1, d-1 );
		gridMat = new THREE.MeshBasicMaterial( { color:0x606060, wireframe:true } );
		grid = new THREE.Mesh( gridGeom, gridMat );
		group.add( grid );
		
		
		var stepX = bbox.w * 2 / ( w - 1 );
		var stepY = bbox.h * 2 / ( h - 1 );
		var stepZ = bbox.d * 2 / ( d - 1 );
		
		for( var i = 0; i < w; i++ )
		{
			for( var j = 0; j < h; j++ )
			{
				for( var k = 0; k < d; k++ )
				{
				
					var pos = new THREE.Vector3( 	bbox.x + i * stepX, 
													bbox.y + j * stepY, 
													bbox.z + k * stepZ );
													
					items.push( new force( pos, .1 + 50 * Math.random() ) );
					
				}
			}
		}
	}
	var buffer0  = [];
	var buffer1  = [];
	var buffer2  = [];
	var buffer3  = [];
	function reset( __w, __h, __d )
	{
		var tmp = animation;
		animation = false;
		w = __w;
		h = __h;
		d = __d;
		createGrid();
		
		var count = 100;
		var angle = 0;
		var step = Math.PI * 2 / count;
		
		var coords = [0.352869334631,0.749904466793,-0.559577092528,-0.391020449810,-0.509291420691,-0.766632412560,0.623391425237,0.056464758702,0.779868489131,-0.873050643131,0.150727326982,0.463749767281,0.246433760971,-0.810524245724,0.531338730827,-0.287404433824,-0.270100805908,0.918936475180,-0.498035680503,0.862289292738,-0.091747669503,-0.924858642742,0.031132024713,-0.379034678452,0.524186631665,-0.172542810440,-0.833940856159,0.938515536487,0.329076329246,-0.104390404187,0.194625753909,-0.930119553581,-0.311445710249,-0.649542376399,-0.746211240999,0.145820036530,0.404677339830,0.869499766268,0.283207355067,0.859393748455,-0.510935678147,0.019675284624,-0.208282645792,0.569911192171,0.794870789163,-0.311898658052,0.330720597878,-0.890698104165];
		if( objects.length == 0 )
		{
			//16
			//42
			//var coords = [-0.140500573441,0.411338672973,-0.900588742457,-0.473463705741,-0.508818475530,-0.718982527964,0.544580468908,0.168060564436,0.821698094718,0.984945358709,-0.119372019544,-0.125031833537,0.838993586600,-0.287145727314,0.462208926678,0.062960184179,-0.106524378061,0.992314754054,0.321793803014,-0.909893921576,-0.261804887094,-0.840121709742,0.436759759672,-0.321615335532,-0.484898614697,-0.818173248321,0.308975514024,-0.079321356490,0.984452021308,-0.156723768450,0.086701999418,-0.705125043169,-0.703762343153,0.832817203365,0.073156695813,-0.548692629673,-0.354701580480,0.200692640617,0.913186318241,-0.307522273622,-0.901200765744,-0.305396840908,-0.836332366802,-0.401265449822,0.373542780988,0.602608286776,0.601391797885,-0.524586653337,-0.446370800026,-0.404051600024,0.798433097079,-0.872455043718,-0.169493054040,-0.458360447548,-0.770932382904,0.105789381079,0.628069953993,-0.434740389697,0.662366242148,0.610140765086,-0.531983394176,0.844026751816,0.067915450782,0.894618706778,0.218065749854,0.390006021596,0.132434999570,0.517488888465,0.845379334874,-0.130248009227,-0.178594673052,-0.975263757631,-0.001983668655,-0.982384898700,0.186858168803,-0.593914130703,0.120023505762,-0.795525210910,-0.858860301785,0.444364521652,0.254753122106,0.676720874384,-0.526827856898,-0.514296866022,-0.049149334431,-0.681903743185,0.729788755067,0.447562818415,-0.814468767494,0.369226418436,-0.756314053200,-0.632084527984,-0.168695587665,-0.482120717876,0.695410907269,-0.532882052474,0.347253034823,0.256986248307,-0.901872161776,0.006262061186,0.908860092051,0.417054094374,0.461814482696,-0.419507850893,0.781498908997,0.454928180203,0.890146316029,-0.026074625552,0.555586918257,0.688795302995,0.465708283707,-0.997770558111,-0.060821362771,0.027471349575,0.413842942566,-0.251332459040,-0.874966291711,0.871115081944,0.487475225702,-0.059383640997,0.134893499315,0.799660229124,-0.585104486905,0.771270472556,-0.636321690865,0.015380582772];
			//var coords = [-0.521407336928,0.575998157263,-0.629571688361,0.448743076995,0.879184495658,0.160200725310,-0.576902663335,0.684330023825,0.445954857394,-0.525521272793,-0.344639498740,0.777850246988,0.525521271862,0.344639496878,-0.777850247920,0.468321898021,0.071630761027,0.880649551749,-0.903677974828,-0.357139469124,-0.236257307231,0.956763413735,-0.290489448234,-0.014820555225,-0.013387000188,-0.593675787561,-0.804592969827,0.141546586528,-0.969838731922,0.198437386192];
			for( var i = 0; i < coords.length; i+=3 )
			{
				new obj( new THREE.Vector3( coords[ i ] 	* 30, 
											coords[ i+1 ] 	* 30, 
											coords[ i+2 ] 	* 30 ), 50 + ( Math.random() - .5 ) * 50 );
			}
			//for( var i = 0; i < count; i++ )
			//{
				//new obj( new THREE.Vector3( ), 50 + ( Math.random() - .5 ) * 50 );
			//}
		}
		objects.forEach( function( e, i, a )
		{	
			var r = _h/2;
			
			e.mesh.position.x = coords[ i ] 	* 30; 
			e.mesh.position.y = coords[ i+1 ] 	* 30;
			e.mesh.position.z = coords[ i+2 ] 	* 30;
			
			e.vel.set( 0, 0, 0 );
			e.acc.set( 0, 0, 0 );
			
			//e.mesh.position.x = Math.cos( angle ) * r * .5;	//-_w / 2 + Math.random() * _w; //
			//e.mesh.position.y = -_h / 4 + i * r / count;		//-_h / 2 + Math.random() * _h;
			//e.mesh.position.z = Math.sin( angle ) * r * .5;	//-_d / 2 + Math.random() * _d; //
			//
			//e.mesh.position.x = -_w / 2 + Math.random() * _w; //
			//e.mesh.position.y = - _h/2 + 1;//-_h / 2 + Math.random() * _h;
			//e.mesh.position.z = -_d / 2 + Math.random() * _d; //
			
			//e.mesh.position.normalize();
			//e.mesh.position.multiplyScalar( r );
			//
			
			
			angle += step * 3;
		});
		
		buffer0 = [];
		buffer1 = [];
		//buildtrail();
		
		animation = tmp;
		
	}
	reset( w, h, d );
	
	function buildtrail()
	{
	//buffer0 = [];
	//buffer1 = [];
	buffer2 = [];
		
		for( var i = 0; i < objects.length; i++ )
		{
			///*
			for( var j = i+1; j < objects.length; j++ )
			{
				var dist = objects[ i ].pos.distanceTo( objects[ j ].pos );
				if( dist < 30 )
				{
					buffer0.push( objects[ i ].pos.clone()  );
					buffer0.push( objects[ i ].last.clone() );
					//buffer0.push( objects[ i ].pos.clone() );
					//buffer0.push( objects[ j ].pos.clone() );
				}
				if( dist > 15 && dist < 20 )
				{
					//buffer2.push( objects[ i ].pos.clone() );
					//buffer2.push( objects[ j ].pos.clone() );
				}
				if( dist > 5 && dist < 25 )
				{
					//buffer1.push( objects[ i ].pos.clone() );
					//buffer1.push( objects[ j ].pos.clone() );
					buffer1.push( objects[ i ].pos.clone() );
					buffer1.push( objects[ j ].pos.clone() );
					
					buffer0.push( objects[ i ].pos.clone()  );
					buffer0.push( objects[ i ].last.clone() );
					buffer0.push( objects[ j ].pos.clone()  );
					buffer0.push( objects[ j ].last.clone() );
				}
			}
			/**/
		}
		
		
		//geom.vertices.push( objects[ 0 ].mesh.position.clone() );
		
		if( line0 != null )
		{
			group.remove( line0 );
			geom0.dispose();
			group.remove( line1 );
			geom1.dispose();
			group.remove( line2 );
			geom2.dispose();
		}
		geom0 = new THREE.Geometry();
		buffer0.forEach( function( e, i, a ){	geom0.vertices.push( e );} );
		geom1 = new THREE.Geometry();
		buffer1.forEach( function( e, i, a ){	geom1.vertices.push( e );} );
		geom2 = new THREE.Geometry();
		buffer2.forEach( function( e, i, a ){	geom2.vertices.push( e );} );
			//this.mesh = new THREE.Mesh( sphereGeom, white );
			//this.mesh.position.copy( e.mesh.position );
			//this.mesh.scale.multiplyScalar( 5 );
			//group.add( this.mesh );
			

		line0 = new THREE.Line( geom0, lmat0 );
		line0.type = THREE.LinePieces;
		group.add( line0 );
		line1 = new THREE.Line( geom1, lmat1 );
		line1.type = THREE.LinePieces;
		group.add( line1 );
		line2 = new THREE.Line( geom2, lmat2 );
		line2.type = THREE.LinePieces;
		group.add( line2 );
		//if( objects.length > 12 ) geom.vertices.push( objects[ objects.length - 12 ].mesh.position.clone() );
		//else geom.vertices.push( objects[ 0 ].mesh.position.clone() );
		
	}
	var iteration = 0;
	function update()
	{
		if( animation )
		{
			iteration++;
			items.forEach( function( e, i, a ){	e.update();	});
			//items.forEach( function( e, i, a ){	console.log( e.vel );	});
			objects.forEach( function( e, i, a ){	e.update();	});
			if( iteration > 1 )
			{
				buildtrail();	
				iteration = 0;
			}
		}
	}
	setInterval( update, 1000 / 30 );
	
	
	function onDown( e )
	{
		//animation = true;
		//update();
		animation = !animation ? true : false;
	}
	window.addEventListener( 'mousedown', onDown );
	
	