/**
 * @author Nicolas Barradeau 
 */

	var particleMat  = new THREE.ParticleBasicMaterial({ color:COLOR_WHITE, size: 2.5 });//, transparent: true, blending: BLEND_ADD } );
	var particleGeom  = new THREE.Geometry();
	var particleSystem = new THREE.ParticleSystem( particleGeom, particleMat );
	group.add( particleSystem );
	
	var time = 0,
		max = 64, 
		animation = false;
		
	function create()
	{
		for( i = 1; i < max; i++ )
		{
			var tot = ( i * 2 );
			for( j = 0; j < tot; j++ )
			{
				particleGeom.vertices.push( new THREE.Vector3( 0,0,0 ) );
			}
		}
	}
	function update()
	{
		time += .01;
		
		var id = 0, 
			dx = 0, 
			dy = 0, 
			dz = 0,
			l = 0;
			
		for( i = 1; i < max; i++ )
		{
			var tot = ( i * 2);
			var t = i / max;
			var radius = ( t * t * t ) * 250;
			var angle =  time * Math.PI * 2;
			var step = Math.PI * 2 / tot;
			for( j = 0; j < tot; j++ )
			{
				angle += step;
				
				p = particleGeom.vertices[ id ];
				
				if( !animation )
				{
					dx = Math.cos( angle ) * radius;
					dy = Math.sin( angle ) * radius;
					dz = Math.sin( t * Math.PI * 3 ) * -20; 
				}
				else
				{
					dx = Math.cos( angle ) * radius;
					dy = - 75 + id % 150;
					dz = Math.sin( angle ) * radius;
				}
				
				p.x += ( dx - p.x ) * .05;
				p.y += ( dy - p.y ) * .05;
				p.z += ( dz - p.z ) * .05;
				
				if( animation )
				{
					p.setLength( 75 * ( 1 + .5 + Math.sin( id * 0.01 ) * .5 ) );
				}
				
				id++;
			}
		}
		particleGeom.verticesNeedUpdate = true;
		
	}
	
	function onDown( e )
	{
		animation = !animation ? true : false;	
	}
	
window.addEventListener( 'mousedown', onDown );
create();
setInterval( update, 1000 / 30 );