/**
 * @author Nicolas Barradeau 
 */
 
	SSAO = true;
	var m = new THREE.Matrix4();
	var t = new THREE.Vector3();
	var q = new THREE.Quaternion();
	var s = new THREE.Vector3();
	
	var animation = false;
	
	var geometry = new THREE.IcosahedronGeometry( 1, 4 );
	var clear = new THREE.MeshBasicMaterial({color:0xEEEEEE} );
	var dark = new THREE.MeshBasicMaterial({color:0x808080});
	
	var obj = function( dir, limit, size )
	{
		
		var mat = limit%2 == 0 ? dark : clear;
		if( limit == 0 )mat = MAT_PINK;
		
		this.mesh = new THREE.Mesh( geometry, mat );
		group.add( this.mesh );
		
		t = t.add( dir );
		this.mesh.position.copy( t );
		
		dir.x += ( Math.random() - .5 ) * 4;
		dir.y += ( Math.random() - .5 ) * 4;
		dir.z += ( Math.random() - .5 ) * 4;
		dir.normalize();
		dir.multiplyScalar( size * 2.5 );
		this.dir = dir.clone();
		
		this.time = limit;
		this.size = size;
		
		this.update = function()
		{
			
			this.time += .1;
			this.mesh.scale.x = 
			this.mesh.scale.y =
			this.mesh.scale.z = this.size * 1.5 + ( .5 + Math.cos( this.time ) * .5 ) * this.size;
			
		}
		this.update();
		
		if( limit > 0 )	items.push( new obj( dir, --limit, size * .9 ) );
		
		return this;
	}
	
	function addMesh()
	{
		for( var i = 0; i < 10; i++ )
		{
			
			t.x = ( Math.random() - .5 ) * 20;
			t.y = ( Math.random() - .5 ) * 20;
			t.z = ( Math.random() - .5 ) * 20;
			
			var dir = new THREE.Vector3( Math.random() - .5, Math.random() - .5, Math.random() - .5 );
			items.push( new obj( dir, 5 + Math.floor( Math.random() * 20 ), 8 ) );
		
		}
		
		for( i = 0; i < 15; i++ )
		{
			
			var id = Math.floor( Math.random() * items.length );
			t.copy( items[ id ].mesh.position );
			
			dir = items[ id ].dir.clone();
			dir.x = ( Math.random() - .5 ) * .05;
			dir.y = ( Math.random() - .5 ) * .05;
			dir.z = ( Math.random() - .5 ) * .05;
			
			items.push( new obj( dir, 3 + Math.floor( Math.random() * 10 ), items[ id ].size ) );
		
		}
			
	}
	
	function update()
	{
		if( animation ) items.forEach( function( e, i, a ){	e.update();	});
	}
	setInterval( update, 1000 / 30 );
	
	
	function onDown( e )
	{
		
		animation = !animation ? true : false;
		if( animation == false )
		{
			while( items[ 0 ] != null ) 
			{
				group.remove( items[0].mesh );
				items.shift();
			}
		
			addMesh();
		}
		
	}
	window.addEventListener( 'mousedown', onDown );
	addMesh();
	